//+-----------------------------------------------------------------------------------+
//|                                                                       test_Ma.mq4 |
//|                                                                               hoz |
//|                                                                                   |
//+-----------------------------------------------------------------------------------+
#property copyright "hoz"
#property link      ""

extern string ___H0 = " ___________   ____________ ";
extern int i_TF = 0,
           i_fastMaPeriod = 10,
           i_slowMaPeriod = 21;
extern string ___H1 = " _____   _______";
extern int i_magic = 3333021;
extern double i_thresholdFromMa = 5;                           //   
// 
double fastMa,
       slowMa;
double pt;
//   
double g_spread,
       g_stopLevel,
       g_tickSize;
//   
#define MA_DIRECT_TO_UP      0                                 //   
#define MA_DIRECT_TO_DOWN    1                                 //   
#define MA_DIRECT_TO_NONE   -1                                 //   
#define SIGNAL_BUY           0                                 //   
#define SIGNAL_SELL          1                                 //   
#define SIGNAL_NO           -1                                 //  

//+-------------------------------------------------------------------------------------+
//|                                                                  |
//+-------------------------------------------------------------------------------------+
int init()
{
   GetMarketInfo();
   
   if (Digits  == 2 || Digits == 4)
       pt = Point;
   if (Digits == 1 || Digits == 3 || Digits == 5)
       pt = Point * 10;
   if (Digits == 6)
       pt = Point * 100;
   if (Digits == 7)
       pt = Point * 1000;
   

  return (0);
}
//+-------------------------------------------------------------------------------------+
//|                                                                |
//+-------------------------------------------------------------------------------------+
int deinit()
{
//----
   
//----
  return (0);
}
//+-------------------------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------------------------+
void GetMarketInfo()
{
  g_spread = MarketInfo(Symbol(),MODE_SPREAD);
  g_stopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL);
  g_tickSize = MarketInfo(Symbol(),MODE_TICKSIZE);
}
//+-------------------------------------------------------------------------------------+
//|                                                                  |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
  return (NormalizeDouble(A, Digits));
}
//+-------------------------------------------------------------------------------------+
//|                                                               |
//+-------------------------------------------------------------------------------------+
bool OpenBuy(double fastMa, double slowMa)
{
   int ticket = -1;
   
   if ((fastMa + i_thresholdFromMa * pt) > Ask)           //      Ask, ..    

       ticket = OrderSend(Symbol(), OP_BUYSTOP, 0.1, ND(fastMa + i_thresholdFromMa * pt), 3, 0, 0, NULL, i_magic, 0);
   
   if (ticket > 0)
 
   return (true);
}
//+-------------------------------------------------------------------------------------+
//|                                                              |
//+-------------------------------------------------------------------------------------+
bool OpenSell(double fastMa, double slowMa)
{
   int ticket = -1;
   
   if ((fastMa - i_thresholdFromMa * pt) < Bid)           //      Bid, ..    
   
       ticket = OrderSend(Symbol(), OP_SELLSTOP, 0.1, ND(fastMa - i_thresholdFromMa * pt), 3, 0, 0, NULL, i_magic, 0);
       
   if (ticket > 0)
    
   return (true);
}
//+-------------------------------------------------------------------------------------+
//|                                                  |
//+-------------------------------------------------------------------------------------+
int GetStateMa(double fastMa, double slowMa)
{
   if (fastMa > slowMa)                          //   , ..
       return (MA_DIRECT_TO_UP);                 // ..  
   
   if (fastMa < slowMa)                          //   , ..
       return (MA_DIRECT_TO_DOWN);               //   
   
   return (MA_DIRECT_TO_NONE);                   //     
}
//+-------------------------------------------------------------------------------------+
//|                                                                      |
//+-------------------------------------------------------------------------------------+
bool Trade(int signal)
{
   if (signal == SIGNAL_BUY)                     //    ..
       if (!OpenBuy(fastMa, slowMa))             // ..
          return(false);
   
   if (signal == SIGNAL_SELL)                   //    ..
       if (!OpenSell(fastMa, slowMa))           // ..
          return(false);
       
   return (true);
}
//+-------------------------------------------------------------------------------------+
//|                                                 |
//+-------------------------------------------------------------------------------------+
int GetSignal()
{
   if (GetStateMa(fastMa, slowMa) == MA_DIRECT_TO_UP)       //    ..
       if ( MathAbs(Ask - fastMa) <= i_thresholdFromMa * pt ) // ..     , <= i_thresholdFromMa..
           return(SIGNAL_BUY);                       // ..   

   if (GetStateMa(fastMa, slowMa) == MA_DIRECT_TO_DOWN)      //    ..
       if ( MathAbs(Bid - fastMa) <= i_thresholdFromMa * pt ) // ..     , <= i_thresholdFromMa..
       return(SIGNAL_SELL);                          // ..   
   
   return (SIGNAL_NO);
}
//+-------------------------------------------------------------------------------------+
//|  start                                                                       |
//+-------------------------------------------------------------------------------------+
int start()
{
   fastMa = iMA(NULL,i_TF,i_fastMaPeriod,0,MODE_EMA,MODE_CLOSE,1);
   slowMa = iMA(NULL,i_TF,i_slowMaPeriod,0,MODE_EMA,MODE_CLOSE,1);

//    
   static datetime lastBarTime = 0;    //    
   
   if (lastBarTime == iTime(NULL, 0, 0))         //      ..
       return (0);                      // ..  

//     
   int signal = GetSignal();
   
//   
   if (signal != SIGNAL_NO)
       if (!Trade(signal))
           return (0);
   
   lastBarTime = iTime(NULL, 0, 0);              //      ..
                                       // ..  
  return (0);
}